#include <QtGui>

#include "mainwindow.h"



MainWindow::MainWindow()
{


    myWidget = new MyWidget;

    myWidget->scrollArea->setWidget(myWidget);

    setCentralWidget(myWidget->scrollArea);
    
    prc = new QDockWidget("Per Cent");
    prc->setWidget(myWidget->prc);
    addDockWidget(Qt::TopDockWidgetArea,prc);

    qualIter = new QDockWidget("Quantity Iteration");
    qualIter->setWidget(myWidget->qualIter);
    addDockWidget(Qt::TopDockWidgetArea,qualIter);

    h0size = new QDockWidget("Start Square Size");
    h0size->setWidget(myWidget->h0Size);
    addDockWidget(Qt::TopDockWidgetArea,h0size);


    qualIterMandel = new QDockWidget("Mandelbrot: Iterations Quan.");
    qualIterMandel->setWidget(myWidget->qualIterMandel);
    addDockWidget(Qt::TopDockWidgetArea,qualIterMandel);

    qualPixMandel = new QDockWidget("Mandelbrot: Pixels Quan.");
    qualPixMandel->setWidget(myWidget->qualPixMandel);
    addDockWidget(Qt::TopDockWidgetArea,qualPixMandel);
    

    /*spil = new QLCDNumber("Pixel Quant");
    spil->setWidget(myWidget->spil);
    addDockWidget(Qt::TopDockWidgetArea,spil);*/


QLCDNumber* spil;
    createActions();
    createMenus();
 

        setWindowTitle("Fractal Analyzator");
        resize(1024,768);
}




 void MainWindow::open()
 {
     QString fileName = QFileDialog::getOpenFileName(this,
                                     tr("Open File"), QDir::currentPath());
     if (!fileName.isEmpty()) {
         QImage image(fileName);
         if (image.isNull()) {
             QMessageBox::information(this, tr("Image Viewer"),
                                      tr("Cannot load %1.").arg(fileName));
             return;
         }


         myWidget->qImage.load(fileName);
         myWidget->resize(myWidget->qImage.size());
         exportAct->setEnabled(true);

     }
 }



 void MainWindow::about()
 {
     QMessageBox::about(this, tr("About Fractal Analyser"),
             "<p>The <b>Fractal Analyzer</b> <p> This program was designed by "
                "Petrochenkow Roman and Vladimir Vitrichenko. "
                ""
               // "<p>You can find description and help in attached file spilan.doc. "
                "<p>Contact email: RPetrochenkow@gmail.com."
                "<p>Enjoy Fractal Analyzer!"
                ""
                "<p>Moscow 2009-2010"
                );
 }

 void MainWindow::createActions()
 {
     openAct = new QAction(tr("&Open..."), this);
     openAct->setShortcut(tr("Ctrl+O"));
     connect(openAct, SIGNAL(triggered()), this, SLOT(open()));


     exitAct = new QAction(tr("E&xit"), this);
     exitAct->setShortcut(tr("Ctrl+Q"));
     connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));

     exportAct = new QAction(tr("E&xport to..."), this);
     exportAct->setShortcut(tr("Ctrl+X"));
     //exportAct->setEnabled(false);
     connect(exportAct, SIGNAL(triggered()), this, SLOT(exportTxt()));


     aboutAct = new QAction(tr("&About"), this);
     connect(aboutAct, SIGNAL(triggered()), this, SLOT(about()));

     aboutQtAct = new QAction(tr("About &Qt"), this);
     connect(aboutQtAct, SIGNAL(triggered()), qApp, SLOT(aboutQt()));
 }

 void MainWindow::createMenus()
 {
     fileMenu = new QMenu(tr("&File"), this);
     fileMenu->addAction(openAct);

     fileMenu->addSeparator();
     fileMenu->addAction(exitAct);

     exportMenu = new QMenu (tr("&Export"), this);
     exportMenu->addAction(exportAct);


     helpMenu = new QMenu(tr("&Help"), this);
     helpMenu->addAction(aboutAct);
     helpMenu->addAction(aboutQtAct);

     menuBar()->addMenu(fileMenu);
     menuBar()->addMenu(exportMenu);
     menuBar()->addMenu(helpMenu);
 }

 void MainWindow::exportTxt()
 {
     myWidget->exportTxt();
 }




