#include <QIODevice>
#include <iostream>
#include <QPainter>
#include "mywidget.h"

MyWidget::MyWidget(QWidget *parent) : QWidget(parent)
{
    /*OPISANIE WIDGETOV start*/
    h0Size = new QSpinBox;
    h0Size->setMaximum(10000);
    h0Size->setMinimum(0);
    h0Size->setMinimumHeight(30);
    h0Size->show();
    h0Size->setSingleStep(128);

    qualIter = new QSpinBox;
    qualIter->setMinimum(1);
    qualIter->setMinimumHeight(30);
    qualIter->show();
    qualIter->setMinimumWidth(100);
    qualIter->setSingleStep(1);


    prc = new QDoubleSpinBox;
    prc->setMaximum(1);
    prc->setMinimum(0);
    prc->setMinimumHeight(30);
    prc->setValue(0.1);
    prc->setSingleStep(0.05);
    prc->setDecimals(4);
    prc->show();

    qualIterMandel = new QSpinBox;
    qualIterMandel->setMaximum(10000);
    qualIterMandel->setMinimum(1);
    qualIterMandel->setMinimumHeight(30);
    qualIterMandel->setMinimumWidth(150);
    qualIterMandel->show();
    qualIterMandel->setSingleStep(1);
    qualIterMandel->setValue(21);

    qualPixMandel = new QSpinBox;
    qualPixMandel->setMaximum(20000);
    qualPixMandel->setMinimum(1);
    qualPixMandel->setMinimumHeight(30);
    qualPixMandel->show();
    qualPixMandel->setMinimumWidth(132);
    qualPixMandel->setSingleStep(100);
    qualPixMandel->setValue(4000);

    scrollArea = new QScrollArea;
    setFocusPolicy(Qt::ClickFocus);
    /*OPISANIE WIDGETOV end*/

    /*SET STANDART VALUES open*/
    qpColor.setRgb(0,0,0);
    h0Size->setValue(128);\
    QImage qImage2(1024,1024,QImage::Format_RGB32);
    qImage=qImage2;
    resize(qImage.size());
    lastPoint = 1;
    scaleFactor = 1;
    /*SET STANDART VALUES close*/

        };
void MyWidget::paintEvent(QPaintEvent *)
{
    QPainter painter(this);
    resize(scaleFactor*qImage.size());
    painter.drawImage(0,0,qImage.scaled(scaleFactor*qImage.size(),Qt::KeepAspectRatio));
    QPen qp(Qt::red);
    qp.setWidth(5);
    painter.setPen(qp);
}
void MyWidget::mousePressEvent ( QMouseEvent * event)
{
	if (true)
	{

            QPoint mpos = event->pos();
            if(event->button() == Qt::LeftButton){
                //qpColor.setRgb(qImage.pixel(mpos/scaleFactor));
                qpArr[lastPoint++] = mpos;//OLOL
                QColor qc(38,44,79);
                qImage.setPixel(mpos/scaleFactor,qc.rgb());
                update();

            };
            if(event->button() == Qt::RightButton){
                scaleFactor=1;
                update();
            };
        }
}

void MyWidget::mashtab()
{
    float koef;
    koef=h0Size->value();
    float x,y;
    x=abs(qpArr[1].x()-qpArr[2].x());
    y=abs(qpArr[1].y()-qpArr[2].y());
    float gip=sqrt(x*x+y*y);
    koef=koef/gip;
    for (int i=3; i<=lastPoint-1; i++)
    {
        x=abs(qpArr[i].x()-qpArr[i+1].x());
        y=abs(qpArr[i].y()-qpArr[i+1].y());
        gip=sqrt(x*x+y*y);
        gip*=koef;
        qprArr[i-2]=gip;

    }

}


void MyWidget::wheelEvent(QWheelEvent * event)
{
    if (event->delta()>0)
    {
        scaleFactor*=1.25;
        update();
    }
    if (event->delta()<0)
    {
        scaleFactor*=0.8;
        update();
    }
}


void MyWidget::exportTxt()
{
    mashtab();
    QString fileName = QFileDialog::getSaveFileName(this,
                                     tr("Export File (*.doc *.csv *.xls)"), QDir::currentPath())  ;

    QFile file(fileName);

    QByteArray qba;
    QString str;
    for(int i=1;i<lastPoint-3;i++)
    {
        //qba+=str.setNum(qualH0Size[i])+';';
        qba+=str.setNum(qprArr[i])+'\n';
    }
    qba.replace(QByteArray("."), QByteArray(","));
    file.open(QIODevice::WriteOnly);
    file.write(qba);
    file.close();
}

void MyWidget::keyPressEvent(QKeyEvent * event)
{
    /*Zdes' vipolnyaetsya metody po najatiu na klavishu...*/
    if (event->key()==Qt::Key_S)//FA
        {
            /*...na klavishu "S"*/
            if(h0Size->value())
            {
                for (int cikl=0; cikl<qualIter->value();cikl++)
                {
                    qualTrue[lastPoint]=mathProcessor();\
                    qualH0Size[lastPoint++]=h0Size->value();
                    h0Size->setValue(h0Size->value()/2);
                    h0Size->update();

                }
            }
        }

    if (event->key()==Qt::Key_P)
        {
        /*...na klavishu "P"*/
             processFracPaint();
        }

        if (event->key()==Qt::Key_M)
        {
         /*...na klavishu "M"*/
            processMandelPaint();
        }
}
 void MyWidget::processFracPaint()//FA
 {

    pixQuant=qualPixMandel->value();
    QImage imFrac(pixQuant,pixQuant,QImage::Format_RGB32);
    qImage=imFrac;
    QColor qc(111,66,200);
    for(int i = 0 ; i<=1023 ;i++)
    {
        for(int k = 0 ; k<=1023 ;k++)
           {
                 qImage.setPixel(i,k,qc.rgb());
           }
    }

    repaint();
   // h0Size->setValue(10);
}


  void MyWidget::processMandelPaint()//FA
 {

    pixQuant=qualPixMandel->value();
    QImage imFrac(pixQuant,pixQuant,QImage::Format_RGB32);
    qImage=imFrac;
    QColor qc(38,44,79);
        float X,Y,X1,Y1,A,B,S,P,C1,C2,Iter,Z;
        A=0;
        B=0;
        S=3.5;
        P=pixQuant;
        C1=0;
        C2=0;
        Iter=0;
        X=0;
        Y=0;

    for (int M = 0 ; M<=P ;M++)
        {
            C1 =  A- S/2 + S*M / P;
            for(int N = 0 ; N<=P ;N++)
                {
                            C2=B-S/2+S*N/P;
                            X=0;
                            Y=0;
                            Iter=1;
                            int iterStop;
                            iterStop=qualIterMandel->value();
                            for(Iter = 2 ; Iter<=iterStop ;Iter++)
                             {
                                 X1=X*X-Y*Y+C1;
                                 Y1=2*X*Y+C2;
                                 X=X1;
                                 Y=Y1;
                                 Z=X*X+Y*Y;
                                 if (Z>4) break;
                            }

                            if (Z<4)
                            {
                                      qImage.setPixel(M,N,qc.rgb());
                            }


                       }
               }
               repaint();
        }



int MyWidget::mathProcessor()//FA
{
    int res = 0;
    int h0SizeTmp=h0Size->value();

    for(int i = 0; i < qImage.width()/h0SizeTmp;i++)
    {
        for(int j = 0; j < qImage.height()/h0SizeTmp;j++)
        {
            int S = 0;
            for(int k = 0; k < h0SizeTmp;k++)
            {
                for(int l = 0; l < h0SizeTmp;l++)
                {
                    QColor c1(qImage.pixel(h0Size->value()*i+k,h0Size->value()*j+l));
                    if(colorAn(c1,qpColor)) S++;
                }
            }
            float fl = h0Size->value()*h0Size->value();
            if((S/fl) > prc->value()) res++; //0<prc<1
        }
    }
    return res;
}


bool MyWidget::colorAn(QColor c1, QColor c2)//FA
{
    int a=10;
    if (abs(c1.red()-c2.red())<a)
    {
        if (abs(c1.green()-c2.green())<a)
        {
            if (abs(c1.blue()-c2.blue())<a) return true;
        }
    }
    return false;
}
